//=====================  board + pinout =====================#
#define v3board 			0
#define v4board 			0
#define v5board 			0
#define m328board 			01
#define m2560board 			0
#define F_CPU	   			8000000
//===========================================================
#define use_twilcd			01
#define use_spitft			0
#define use_net 			0
#define USE_MMC 			0
#define use_bitbang 		0
#define enc_spi_avr 		01
#define sd_spi_avr 			01
#define use_fb				01
//================================================================================
#define AVR 				1
#define use_watchdog  		1	
#define use_twi  			1
#define timer_smh			1
//================================================================================
#include <stdio.h>
#include <avr/io.h>
#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "defines.h"

#include "globals.h"
#include "pinout.k"
#include "config.k"

//================================================================================

#if  use_twi
#define i2c_ds1307 1
#include "twimaster.k"
#include "kk_twixx.k"
#endif

#if use_twilcd 
#define use_glcd     	0
#include "twilcd.k" //C:\WinAVRkk\kklibx\//
#include "lcd_std_func.k" //C:\WinAVRkk\kklibx\//
#endif


#if use_spitft
//#if use_lcdili9320
#define use_glcd     		1
#define DISP_ORIENTATION  0 //0x0 screen rotation
#include "C:\zuc\lcd\lowlevel_spi_tft.k" //C:\WinAVRkk\kklibx\//
#include "C:\zuc\lcd\colors.k" //C:\WinAVRkk\kklibx\//
#include "C:\zuc\lcd\new_lib_fonts.k" //C:\WinAVRkk\kklibx\//
#include "C:\zuc\lcd\new_ili9320.k" //C:\WinAVRkk\kklibx\//
#include "C:\zuc\lcd\new_lib_glcd.k"
#include "C:\zuc\lcd\lcd_std_func.k"
#endif
//=============================================================================

#ifdef ow_port
#include "neuds1820.h"
#endif


	#ifdef ir_in_port
	#include "FB_globals.k"
	#include "FB_RC5_64.k"
	#include "FB_irMenu.k"
	#endif



#if USE_MMC
	//+++++++++++++++++++++ mmc +++++++++++++++++++++++++++++++++++
	#include "C:\zuc\chan_sd\ffconf.h"
	#include "C:\zuc\chan_sd\integer.h"
	#include "C:\zuc\chan_sd\diskio.h"
	#include "C:\zuc\chan_sd\ff.h"
	#include "C:\zuc\chan_sd\ff.c"
//	#include "mmc_avr.c"
	#include "mmc_32f1_c.h"
//	FATFS FatFs;		//FatFs work area needed for each volume 
	FIL Fil;			/* File object needed for each open file */
	//--------------------------------------------------------
#endif


#if use_net
#include "wconfig_network.h"
#include "C:\zuc\enc38j60\encspi.h"
#include "C:\zuc\enc38j60\enc28j60.h"
#include "C:\zuc\enc38j60\enc28j60_c.h"
/**************************************/
#include <C:\zuc\net\wstack.h>
#include <C:\zuc\net\wstack_c.h>
#include "C:\zuc\net\net_tools.h"
#include "C:\zuc\net\dnsc.h"
#include "C:\zuc\net\dnsc_c.h"

//#include "udp.h"
#include "C:\zuc\net\ntp.h"
#include "C:\zuc\net\ntpc.h"
//#include "telnetd.h"
//#include "telnetdc.h"
typedef char PROGMEM prog_char;
#define PGM_P const prog_char *
#include <C:\zuc\net\wkkstring.h>
//#include "base64.h"
//#include "base64.c"
#include <C:\zuc\net\whttpd.h>
//#include <ywebpage.h>
#include <C:\zuc\net\wwebpage.h>
//#include "translate.h"
#include <C:\zuc\net\translate_c.h>
//#include "yhttpd_c.h"
char pgm_read_bytex(uint8_t *x){return *x;}
#include <C:\zuc\net\whttpd_c.h>
#endif
#if 0
#endif


//###################################################################
int main(void)
{
gpio_init();
sbi(bool1,schalterProgrammstart);
ds1820_start_meas();

#if timer_smh
init_timer_smh();
#endif



#if  use_twi
ds1307gefunden=1;
i2c_init();               // init I2C interface
ds1307gefunden = i2c_start(0xd0);
if (ds1307gefunden==0) {
kk_ds1307_getAll_to_global_struct_zt();}
#endif




#if use_twilcd || use_spitft
lcd_init();
#endif



//lcd_clear(0);   

#if USE_MMC //++++++++++++++ foolproof ++++++++++++++
	UINT bw,res;
	res=	f_mount(&FatFs, "", 0);		/* Give a work area to the default drive */
	#if 1
		res=f_open(&Fil, "newfile.txt", FA_WRITE | FA_CREATE_ALWAYS); 	/* Create a file */
		if (res== FR_OK) {
				res=	f_write(&Fil, "It works!\r\n", 11, &bw);	
			f_close(&Fil);								/* Close the file */
			if (bw == 11) {		/* Lights green LED if data written well */
				lgw(4,1,"foolproof ok    ");
			} else{
				lgw(4,1,"foolproof failed");
			}
		}
	#endif
#endif //-------------- foolproof --------------

#if use_net
networkdevice_init();
//enc_init();
stack_init();
dns_init();
dns_query(hostname);
httpd_init();
ntp_init();

//lg(2,1);li(myip[0]);lw(".");li(myip[1]);lw(".");li(myip[2]);lw(".");li(myip[3]);lw(" ");
tmp32_ptr=myip;//myip+1;
lg(2,1);lcd_ip(*tmp32_ptr);
wait;
#endif


//================================================
asm("Sprung:");
lg(1,1);li2(hou);lw(":");li2(min);lw(":");
while(1){
//================================================
//==               polling                      ==
//================================================
		#ifdef ir_in_port
		if(ir_pin && !gp_timer){
		led_on;
		ir_menu();
		gp_timer=2;
		led_off;
		bool_fb=0;}
		#endif


		#if use_net
		eth_get_data();
		#endif


//++++++++++++ volleSecunde ++++++++++++++++++++
if(sec!=SECalt){SECalt=sec;lcd_time();
//================================================
//==             each second                    ==
//================================================





//++++++++++++ volleMinute ++++++++++++++++++++
if(min!=min_alt||gbi(bool1,schalterProgrammstart))
{min_alt=min;wdt_reset();//lcd_time_min();
//================================================
//==             each minute                    ==
//================================================

//+++++++++ min5 ++++++++++++++++++
if((min%6==4 )){
{ds1820_start_meas();}
}//--------- min5 ------------------

//+++++++++ min6 ++++++++++++++++++
if((min%6==0 )){
{ds1820_auslesen_to_global_TR();}
 //        	                anzeige_grafik();
}//--------- min6 ------------------



//================================================
//==            this is the end                 ==
//================================================
//-------------- volleSecunde -----------------
if(gbi(bool1,schalterProgrammstart)){cbi(bool1,schalterProgrammstart);}
}//min
}//sec
}//while(1)
return(0);
}


	
    