#ifndef _ds1820_c
#define _ds1820_c

//================= ds18b20 =============================
//    ____
// ___________
//_____________
// 1   2   3
//GND DAT VCC
//=======================================================
//pinout 0.10

#if arm_cortex
#define ow_lx 1
#define ow_ly 5

#define owds1820_clr 	pinCLR(owds1820_port,owds1820_pin)
#define owds1820_set 	pinSET(owds1820_port,owds1820_pin)
#define owds1820_output pinDIRout(owds1820_port,owds1820_pin)
#define owds1820_input 	pinDIRin(owds1820_port,owds1820_pin)
#define owds1820_val 	pinVAL(owds1820_port,owds1820_pin)
#define xsei()
#define xcli()

#else//atmega avr
#define owds1820_port ow_port
#define owds1820_pin ow_pin
#define ow_lx 1
#define ow_ly 5
//#define owds1820_port C
//#define owds1820_pin 5

#define owds1820_output   	pinDIRout(owds1820_port,owds1820_pin)
#define owds1820_clr 		pinCLR(owds1820_port,owds1820_pin)
#define owds1820_set 		pinSET(owds1820_port,owds1820_pin)
#define owds1820_input 		pinDIRin(owds1820_port,owds1820_pin)
#define owds1820_val 		pinVAL(owds1820_port,owds1820_pin)
#define  xcli cli
#define  xsei sei
#endif

int16_t CelsiusTemp,tmp1820ds0;
uint8_t var_ds1820_list_all=0,var_ds1820_list_zl=0,error_tr_ww,error_tr_wzb;

int16_t tr_au,tr_erdvl,tr_erdrl;
int16_t
tr_ww,tr_vl1,tr_rl,tr_rlu,tr_vlu,tr_wzl,tr_wzb,tr_lel,tr_leb,tr_lul,
tr_lub,tr_nol,tr_nob,tr_vl1alt,tr_rlalt,tr_sollvl,tr_sollww,tr_vlualt,tr_rlualt;

int16_t midea_gs,midea_fl,midea_vl,midea_rl,spartec_vl,spartec_rl;

int16_t temp_m3_au, temp_m3_az;
//------------ hardware --------------------
unsigned char w1_reset(void){
  unsigned char err;
  owds1820_clr;
  owds1820_output;
_delay_us(480);
  xcli();
  owds1820_input;
_delay_us(66);
  err = owds1820_val;			// no presence detect
  xsei();
_delay_us(480-66);
 if( (owds1820_val) == 0 )err = 1;		// short circuit
_delay_ms(1);//kk ge�ndert 30.12.12
return err;
}

unsigned char w1_bit_io( unsigned char b ){
xcli();
owds1820_output;
_delay_us(1);
 if(b) owds1820_input;
_delay_us(14);
 if( (owds1820_val) == 0 )    b = 0;
_delay_us(45);
 owds1820_input;
_delay_ms(1);//kk ge�ndert 30.12.12
  xsei();
  return b;
}

unsigned int w1_byte_wr( unsigned char b ){
  unsigned char i = 8, j;
  do{ j = w1_bit_io( b & 1 );
    b >>= 1;
    if( j )
      b |= 0x80;
  }while( --i );
  return b;
}
unsigned int w1_byte_rd( void ){
  return w1_byte_wr( 0xFF );
}
//------------------------------------------------------
// DS1820 commands
#define MATCH_ROM	0x55
#define SKIP_ROM	0xCC
#define	SEARCH_ROM	0xF0
#define CONVERT_T	0x44
#define READ_OW		0xBE
#define WRITE_OW		0x4E
#define EE_WRITE	0x48
#define EE_RECALL	0xB8
#define	SEARCH_FIRST	0xFF		// start new search
#define	PRESENCE_ERR	0xFF
#define	DATA_ERR		0xFE
#define LAST_DEVICE		0x00		// last device found


#define idata
unsigned char w1_rom_search( unsigned char diff, unsigned char idata *id )
{
  unsigned char i, j, next_diff;
  char b;

  if( w1_reset() )
    return PRESENCE_ERR;			// error, no device found
  w1_byte_wr( SEARCH_ROM );			// ROM search command
  next_diff = LAST_DEVICE;			// unchanged on last device
  i = 8 * 8;					// 8 bytes
  do{
    j = 8;					// 8 bits
    do{
      b = w1_bit_io( 1 );			// READ_OW bit
      if( w1_bit_io( 1 ) ){			// READ_OW complement bit
	if( b )					// 11
	  return DATA_ERR;			// data error
      }else{
	if( !b ){				// 00 = 2 devices
	  if( diff > i ||
	    ((*id & 1) && diff != i) ){
	    b = 1;				// now 1
	    next_diff = i;			// next pass 0
	  }
	}
      }
      w1_bit_io( b );     			// WRITE_OW bit
      *id >>= 1;
      if( b )					// store bit
	*id |= 0x80;
      i--;
    }while( --j );
    id++;					// next byte
  }while( i );
  return next_diff;				// to continue search
}


void w1_command( unsigned char command, unsigned char idata *id )
{
  unsigned char i;
  w1_reset();
  if( id ){
    w1_byte_wr( MATCH_ROM );			// to a single device
    i = 8;
    do{
      w1_byte_wr( *id );
      id++;
    }while( --i );
  }else{
    w1_byte_wr( SKIP_ROM );			// to all devices
  }
  w1_byte_wr( command );
}


void ds1820_start_meas( void ){
  if( owds1820_val ){
    w1_command( CONVERT_T, NULL );
   owds1820_set;
    owds1820_output;			// parasite power on
  }else{
    //uputsnl( "Short Circuit !" );
  }
}



void read_meas( void )
{
 uint8_t i;

 u8 id[8], diff;
// uchar s[30];
//  uchar i;
  int16_t temp;

  for( diff = SEARCH_FIRST; diff != LAST_DEVICE; ){
    diff = w1_rom_search( diff, id );

    if( diff == PRESENCE_ERR ){
        //uputsnl( "No Sensor found" );


#ifdef lcd_goto
		lcd_goto(1,10);
		lcd_write ( "NSF" );
#endif


	break;
    }

    if( diff == DATA_ERR ){
#ifdef lcd_goto
		lcd_goto(1,10);
		lcd_write( "Bus Error" );
#endif
        break;
		}

if( id[0] == 0x28 || id[0] == 0x10 ){	// temperature sensor

	w1_byte_wr( READ_OW );			// READ_OW command
      temp = w1_byte_rd();			// low byte
      temp |= (u8)w1_byte_rd() << 8;		// high byte
      if( id[0] == 0x10 )			// 9 -> 12 bit
        temp <<= 3;
/*
if((temp>>10)==0b111111){
//Minusgrad=1;
//temp=~temp;
//lcd_goto(2,5);
//lcd_write("MInus");
//lcd_int((temp >> 4));
CelsiusTemp=(temp >> 4)*10+10+(temp << 12) / 6553 ;
}else{
//Minusgrad=0;
CelsiusTemp=(temp >> 4)*10+(temp << 12) / 6553 ;
}
*/


//CelsiusTemp=((temp&0b1111000000000000) | (temp>>4) )*10  + (temp << 12) / 6553 ;
if(gbi(temp,15)){//negativ
CelsiusTemp=((0xf000) | (temp>>4) )*10-
(10-((temp & 0x000f)*10+8)/16);
}else{//positiv
CelsiusTemp=( (temp>>4) )*10+
		((temp & 0x000f)*10+8)/16;
}

#if 1//ds1820verbose
		lcd_goto(1,10);
		lcd_hex16 ((id[1]<<8)+id[7]);
		lcd_write(":");
		lcd_int (CelsiusTemp);
#endif

if(var_ds1820_list_all){


if(var_ds1820_list_zl>12)
		lcd_goto(var_ds1820_list_zl-11,1);
		else
		lcd_goto(var_ds1820_list_zl+2,1);


		lcd_int(var_ds1820_list_zl);
		lcd_write(":   ");
		lcd_hex16((id[1]<<8)+id[7]);
		lcd_write(" - ");
		lcd_int (CelsiusTemp);
if(var_ds1820_list_zl==12){wait;wait;wait;wait;wait;}


ds1820_id[var_ds1820_list_zl]=(id[1]<<8)+id[7];
ds1820_temp[var_ds1820_list_zl]=CelsiusTemp;

var_ds1820_list_zl++;


}



if(CelsiusTemp==849||CelsiusTemp==850||CelsiusTemp==851)//kein Messergebnis
{
//	lcd_int(CelsiusTemp);			//char
//	lcd_goto(1,1);
}else{
 switch ((id[1]<<8)+id[7])// nach crc-wert sortieren
  {
  case (CRCsensor000):ds1820_temp[0]	=CelsiusTemp;break;
  case (CRCsensor001):ds1820_temp[1]	=CelsiusTemp;break;
  case (CRCsensor002):ds1820_temp[2]	=CelsiusTemp;break;
  case (CRCsensor003):ds1820_temp[3]	=CelsiusTemp;break;
  case (CRCsensor004):ds1820_temp[4]	=CelsiusTemp;break;
#if CRCsensor005 > 20
  case (CRCsensor005):ds1820_temp[5]	=CelsiusTemp;break;
  case (CRCsensor006):ds1820_temp[6]	=CelsiusTemp;break;
  case (CRCsensor007):ds1820_temp[7]	=CelsiusTemp;break;
  case (CRCsensor008):ds1820_temp[8]	=CelsiusTemp;break;
  case (CRCsensor009):ds1820_temp[9]	=CelsiusTemp;break;
#endif
#if CRCsensor010 > 20
  case (CRCsensor010):ds1820_temp[10]	=CelsiusTemp;break;
   case (CRCsensor011):ds1820_temp[11]	=CelsiusTemp;break;
   case (CRCsensor012):ds1820_temp[12]	=CelsiusTemp;break;
   case (CRCsensor013):ds1820_temp[13]	=CelsiusTemp;break;
   case (CRCsensor014):ds1820_temp[14]	=CelsiusTemp;break;
   case (CRCsensor015):ds1820_temp[15]	=CelsiusTemp;break;
   case (CRCsensor016):ds1820_temp[16]	=CelsiusTemp;break;
   case (CRCsensor017):ds1820_temp[17]	=CelsiusTemp;break;
   case (CRCsensor018):ds1820_temp[18]	=CelsiusTemp;break;
   case (CRCsensor019):ds1820_temp[19]	=CelsiusTemp;break;
#endif
 /*
//case (CRCsensor02):tr_rl 	=CelsiusTemp;break;
case (CRCsensor03):tr_nob	=CelsiusTemp;break;
case (CRCsensor04):tr_wzl	=CelsiusTemp;break;
case (CRCsensor05):tr_rlu	=CelsiusTemp;break;
//case (CRCsensor06):tr_erdrl	=CelsiusTemp;break;
case (CRCsensor07):tr_nol	=CelsiusTemp;break;
case (CRCsensor08):tr_vl1	=CelsiusTemp;break;
case (CRCsensor09):tr_spartec_heissgas	=CelsiusTemp;
error_tr_spartec_heissg=0;
break;
case (CRCsensor10):tr_wzb	=CelsiusTemp;
error_tr_wzb=0;
break;
case (CRCsensor11):tr_leb	=CelsiusTemp;break;
//case (CRCsensor12):tr_vlu	=CelsiusTemp;break;
case (CRCsensor13):tr_ww 	=CelsiusTemp;
error_tr_ww=0;
break;
case (CRCsensor14):tr_lul	=CelsiusTemp;break;
case (CRCsensor15):tr_au 	=CelsiusTemp;break;
case (CRCsensor16):tr_lel	=CelsiusTemp;break;



case (CRCsensor17):midea_heiz_vl	=CelsiusTemp;break;
case (CRCsensor18):midea_heiz_rl	=CelsiusTemp;break;
case (CRCsensor19):midea_klima_vl	=CelsiusTemp;break;
case (CRCsensor20):midea_klima_rl	=CelsiusTemp;break;
case (CRCsensor21):spartec_vl	=CelsiusTemp;break;
case (CRCsensor22):spartec_rl	=CelsiusTemp;break;
*/
  }
}// if 850

//	sprintf( s, "%02X", id[7] );
//	lcd_write( s );

//	lcd_write( " ");






//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


#if verbose_ds1820
//zl_sec_timer0=0;
//zl_timer0=0;
#ifdef lcd_goto
	lcd_goto(1,20);
	lcd_int(CelsiusTemp);
	lcd_goto(2,1);
for(i=0;i<8;i++){
	lcd_int(id[i]);
//	lcd_int(zl_timer0);
}
#endif
#else

_delay_ms(7);//twi64ok

#endif




/*lcd_goto(3,1);
	lcd_int(id[0]);
	lcd_write( " ");
	lcd_int(id[1]);
	lcd_write( " ");
	lcd_int(id[2]);
	lcd_write( " ");
	lcd_int(id[3]);
	lcd_write( " ");
lcd_goto(4,1);
	lcd_int(id[4]);
	lcd_write( " ");
	lcd_int(id[5]);
	lcd_write( " ");
	lcd_int(id[6]);
	lcd_write( " ");
	lcd_int(id[7]);
	lcd_write( " ");*/
/*
#if use_glcd
glcd_goto(1,1);
#else
lcd_goto(1,1);
#endif
*/

   }
  }
 // //uputsnl( "" );
//lcd_write( "" );
}

//------------------------------------------------------------------------------
void 	ds1820_auslesen_to_global_TR(){
	u8 i;
for(i=0;i<anz_sensor;i++)ds1820_temp[i]	=851;

uint8_t  durchlauf;

//ds1820_start_meas();
#if use_wdt
//wdt_reset(7);
#endif
//_delay_ms(1000);
#if use_wdt
//wdt_reset(7);
#endif
read_meas();
#if use_wdt
//wdt_reset(7);
#endif

/*
_delay_ms(1000);
#if use_wdt
//wdt_reset(7);
#endif
ds1820_start_meas();
#if use_wdt
//wdt_reset(7);
#endif
_delay_ms(1000);
#if use_wdt
//wdt_reset(7);
#endif
read_meas();
*/



#if use_wdt
//wdt_reset(7);
#endif
/*  init_timer();
 second = 0;
 durchlauf=0;
 while(durchlauf<3)				// main loop
  { if( second == 1 ){ds1820_start_meas();second = 2;}
    if( second == 3 ){read_meas();second = 0;durchlauf++;}
  }

#ifdef lcd_goto
  	lcd_goto(1,10);
	lcd_int(CelsiusTemp);
#endif  */
 return;
 }


//=================================================
#if 1//v4board || v3board || v5board || arm_cortex
void 	ds1820_list_all()
   {

   lcd_clear(BLACK);
var_ds1820_list_all=1;
ds1820_start_meas();
_delay_ms(1000);
read_meas();
var_ds1820_list_all=0;
var_ds1820_list_zl=0;
return;
 }
#endif
u8 ds1820_testlauf=1;

//====================================
void  ds1820_messung(void)
  {
// 	for(i=0;i<9;i++) {TR[i]=850;}
//tempRlDeltaX=tr_vlu + tr_rlu;


//Fehlermeldung bei 10Fehlmessungen
/*error_tr_spartec_heissg++;
error_tr_wzb++;
error_tr_ww++;*/
ds1820_auslesen_to_global_TR();
/*if(error_tr_wzb>10)tr_wzb=851;
if(error_tr_ww>10)tr_ww=851;
if(error_tr_spartec_heissg>10)tr_ww=851;*/


if(tr_lul!=851){ds1820_testlauf=0;}

if(ds1820_testlauf==1){
#if use_glcd
frontcolor=RED;
#endif
tr_au=40;
tr_ww=404;
tr_wzb=180;
tr_wzl=170;
tr_lub=260;
//tr_lul=190;
tr_nob=190;
tr_nol=220;
tr_leb=190;
tr_lel=190;

}else{
#if use_glcd
frontcolor=BLACK;
#endif
}
}
#endif
